VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Notification"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 03/2023

Option Explicit

' ----==== Const ====----
Private Const WindowsUINotificationsNotification As String = "Windows.UI.Notifications.Notification"
Private Const IID_INotification As String = "{108037fe-eb76-4f82-97bc-da07530a2e20}"

' ----==== Enums ====----
Private Enum vtb_Interfaces

    ' INotification
    INotification_GetExpirationTime = 6
'    INotification_PutExpirationTime = 7
    INotification_GetVisual = 8
'    INotification_PutVisual = 9
                        
    ' IReference_xxx
    IReference_GetValue = 6
    
End Enum

' ----==== Variablen ====----
Private m_pINotification As Long

' ----==== Class ====----
Private Sub Class_Initialize()
    '
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pINotification)
End Sub

' ----==== Properties ====----
Public Property Get Ifc() As Long
    Ifc = m_pINotification
End Property

Public Property Let Ifc(ByVal pINotification As Long)
    Call ReleaseIfc(m_pINotification)
    m_pINotification = pINotification
End Property

' INotification
Public Property Get ExpirationTime() As Date
    Dim Ret As Currency
    If m_pINotification <> 0& Then
        Dim pIReference As Long
        If Invoke(m_pINotification, _
                  INotification_GetExpirationTime, _
                  VarPtr(pIReference)) = S_OK Then
            Dim value As Windows_Foundation_DateTime
            If Invoke(pIReference, _
                      IReference_GetValue, _
                      VarPtr(value)) = S_OK Then
                Ret = DateTime2VBDate(value)
            End If
            Call ReleaseIfc(pIReference)
        End If
    End If
    ExpirationTime = Ret
End Property

'    INotification_PutExpirationTime = 7

Public Property Get Visual() As NotificationVisual
    Dim Ret As New NotificationVisual
    If m_pINotification <> 0& Then
        Dim pINotificationVisual As Long
        If Invoke(m_pINotification, _
                  INotification_GetVisual, _
                  VarPtr(pINotificationVisual)) = S_OK Then
            Ret.Ifc = pINotificationVisual
        End If
    End If
    Set Visual = Ret
End Property

'    INotification_PutVisual = 9

' ----==== Functions ====----

' ----==== Invoke Interface ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


