VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "NotificationBindings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 03/2023

Option Explicit

' ----==== Const ====----

' ----==== Enums ====----
Private Enum vtb_Interfaces

    'IVector
    IVector_GetAt = 6
    IVector_GetSize = 7
    
End Enum

' ----==== Variablen ====----
Private m_pIVector As Long

' ----==== Class ====----
Private Sub Class_Initialize()
    '
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIVector)
End Sub

' ----==== Properties ====----
Public Property Get Ifc() As Long
    Ifc = m_pIVector
End Property

Public Property Let Ifc(ByVal pIVector As Long)
    Call ReleaseIfc(m_pIVector)
    m_pIVector = pIVector
End Property

' ----==== Functions ====----
'IVector
Public Function GetAt(ByVal index As Long) As NotificationBinding
    Dim Ret As New NotificationBinding
    If m_pIVector <> 0& Then
        Dim pINotificationBinding As Long
        If Invoke(m_pIVector, _
                  IVector_GetAt, _
                  index, _
                  VarPtr(pINotificationBinding)) = S_OK Then
            Ret.Ifc = pINotificationBinding
        End If
    End If
    Set GetAt = Ret
End Function

Public Function GetSize() As Long
    Dim Ret As Long
    If m_pIVector <> 0& Then
        Dim value As Long
        If Invoke(m_pIVector, _
                  IVector_GetSize, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    GetSize = Ret
End Function

' ----==== Invoke Interface ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


