VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "UserNotification"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 03/2023

Option Explicit

' ----==== Const ====----
Private Const WindowsUINotificationsUserNotification As String = "Windows.UI.Notifications.UserNotification"
Private Const IID_IUserNotification As String = "{adf7e52f-4e53-42d5-9c33-eb5ea515b23e}"

' ----==== Enums ====----
Private Enum vtb_Interfaces

    ' IUserNotification
    IUserNotification_GetNotification = 6
'    IUserNotification_GetAppInfo = 7
    IUserNotification_GetId = 8
    IUserNotification_GetCreationTime = 9
                        
End Enum

' ----==== Variablen ====----
Private m_pIUserNotification As Long

' ----==== Class ====----
Private Sub Class_Initialize()
    '
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIUserNotification)
End Sub

' ----==== Properties ====----
Public Property Get Ifc() As Long
    Ifc = m_pIUserNotification
End Property

Public Property Let Ifc(ByVal pIUserNotification As Long)
    Call ReleaseIfc(m_pIUserNotification)
    m_pIUserNotification = pIUserNotification
End Property

' IUserNotification
Public Property Get Notification() As Notification
    Dim Ret As New Notification
    If m_pIUserNotification <> 0& Then
        Dim pINotification As Long
        If Invoke(m_pIUserNotification, _
                  IUserNotification_GetNotification, _
                  VarPtr(pINotification)) = S_OK Then
            Ret.Ifc = pINotification
        End If
    End If
    Set Notification = Ret
End Property

'    IUserNotification_GetAppInfo = 7

Public Property Get Id() As Long
    Dim Ret As Long
    If m_pIUserNotification <> 0& Then
        Dim value As Long
        If Invoke(m_pIUserNotification, _
                  IUserNotification_GetId, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    Id = Ret
End Property

Public Property Get CreationTime() As Date
    Dim Ret As Currency
    If m_pIUserNotification <> 0& Then
        Dim value As Windows_Foundation_DateTime
        If Invoke(m_pIUserNotification, _
                  IUserNotification_GetCreationTime, _
                  VarPtr(value)) = S_OK Then
            Ret = DateTime2VBDate(value)
        End If
    End If
    CreationTime = Ret
End Property

' ----==== Functions ====----

' ----==== Invoke Interface ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

