VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "UserNotifications"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 03/2023

Option Explicit

' ----==== Const ====----

' ----==== Enums ====----
Private Enum vtb_Interfaces

    'IReadOnlyList
    IReadOnlyList_GetAt = 6
    IReadOnlyList_GetSize = 7
    
End Enum

' ----==== Variablen ====----
Private m_pIReadOnlyList As Long

' ----==== Class ====----
Private Sub Class_Initialize()
    '
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIReadOnlyList)
End Sub

' ----==== Properties ====----
Public Property Get Ifc() As Long
    Ifc = m_pIReadOnlyList
End Property

Public Property Let Ifc(ByVal pIReadOnlyList As Long)
    Call ReleaseIfc(m_pIReadOnlyList)
    m_pIReadOnlyList = pIReadOnlyList
End Property

' ----==== Functions ====----
'IReadOnlyList
Public Function GetAt(ByVal index As Long) As UserNotification
    Dim Ret As New UserNotification
    If m_pIReadOnlyList <> 0& Then
        Dim pIUserNotification As Long
        If Invoke(m_pIReadOnlyList, _
                  IReadOnlyList_GetAt, _
                  index, _
                  VarPtr(pIUserNotification)) = S_OK Then
            Ret.Ifc = pIUserNotification
        End If
    End If
    Set GetAt = Ret
End Function

Public Function GetSize() As Long
    Dim Ret As Long
    If m_pIReadOnlyList <> 0& Then
        Dim value As Long
        If Invoke(m_pIReadOnlyList, _
                  IReadOnlyList_GetSize, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    GetSize = Ret
End Function

' ----==== Invoke Interface ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


