VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   3015
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   4560
   LinkTopic       =   "Form1"
   ScaleHeight     =   3015
   ScaleWidth      =   4560
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 03/2023

Option Explicit

Private Sub Form_Load()
    Dim Listener As New UserNotificationListener
    If Listener.Current Then
        If Listener.RequestAccessAsync = UserNotificationListenerAccessStatus_Allowed Then
            Dim Notifications As UserNotifications
            Set Notifications = Listener.GetNotificationsAsync(NotificationKinds_Toast)
            If Notifications.Ifc <> 0& Then
                Dim NotificationsCount As Long
                NotificationsCount = Notifications.GetSize
                If NotificationsCount > 0& Then
                    Dim NotificationsItem As Long
                    For NotificationsItem = 0 To NotificationsCount - 1
                        Dim UsrNotification As UserNotification
                        Set UsrNotification = Notifications.GetAt(NotificationsItem)
                        If UsrNotification.Ifc <> 0& Then
                            Dim Toast As UserNotification
                            Set Toast = Listener.GetNotification(UsrNotification.Id)
                            If Toast.Ifc <> 0& Then
                                Debug.Print "Toast Nr.: " & CStr(NotificationsItem + 1)
                                Debug.Print "Toast Id: " & Toast.Id
                                Debug.Print "Toast CreationTime: " & Toast.CreationTime
                                Debug.Print "Toast ExpirationTime: " & Toast.Notification.ExpirationTime
                                Dim ToastVisualBindings As NotificationBindings
                                Set ToastVisualBindings = Toast.Notification.Visual.Bindings
                                If ToastVisualBindings.Ifc <> 0& Then
                                    Dim ToastVisualBindingsCount As Long
                                    ToastVisualBindingsCount = ToastVisualBindings.GetSize
                                    If ToastVisualBindingsCount > 0& Then
                                        Dim ToastVisualBindingsItem As Long
                                        For ToastVisualBindingsItem = 0 To ToastVisualBindingsCount - 1
                                            Dim ToastVisualBinding As NotificationBinding
                                            Set ToastVisualBinding = ToastVisualBindings.GetAt(ToastVisualBindingsItem)
                                            If ToastVisualBinding.Ifc <> 0& Then
                                                Debug.Print "ToastVisualBinding.Language: " & ToastVisualBinding.Language
                                                Debug.Print "ToastVisualBinding.Template: " & ToastVisualBinding.Template
                                                Dim ToastVisualBindingHints As NotificationHints
                                                Set ToastVisualBindingHints = ToastVisualBinding.Hints
                                                If ToastVisualBindingHints.Ifc <> 0& Then
                                                    Dim ToastVisualBindingHintsCount As Long
                                                    ToastVisualBindingHintsCount = ToastVisualBindingHints.GetSize
                                                    If ToastVisualBindingHintsCount > 0& Then
                                                        Dim KeyValuePair() As KeyValuePair_HSTRING_HSTRING
                                                        KeyValuePair = ToastVisualBindingHints.GetKeyValuePairs
                                                        Dim ToastVisualBindingHintsItem As Long
                                                        For ToastVisualBindingHintsItem = 0 To ToastVisualBindingHintsCount - 1
                                                            Debug.Print "ToastVisualBindingHints.key: " & KeyValuePair(ToastVisualBindingHintsItem).key
                                                            Debug.Print "ToastVisualBindingHints.value: " & KeyValuePair(ToastVisualBindingHintsItem).value
                                                        Next
                                                    End If
                                                    Set ToastVisualBindingHints = Nothing
                                                End If
                                                Dim ToastTextElements As NotificationTexts
                                                Set ToastTextElements = ToastVisualBinding.GetTextElements
                                                If ToastTextElements.Ifc <> 0& Then
                                                    Dim ToastTextElementsCount As Long
                                                    ToastTextElementsCount = ToastTextElements.GetSize
                                                    If ToastTextElementsCount > 0& Then
                                                        Dim ToastTextElementsItem As Long
                                                        Dim ToastTitle As String
                                                        Dim ToastMessage As String
                                                        For ToastTextElementsItem = 0 To ToastTextElementsCount - 1
                                                            ToastTitle = vbNullString
                                                            ToastMessage = vbNullString
                                                            Dim ToastTextElement As NotificationText
                                                            Set ToastTextElement = ToastTextElements.GetAt(ToastTextElementsItem)
                                                            If ToastTextElement.Ifc <> 0& Then
                                                                Debug.Print "ToastTextElement.Language: " & ToastTextElement.Language
                                                                Debug.Print "ToastTextElement.Kind: " & ToastTextElement.Kind
                                                                Dim ToastTextHints As NotificationTextHints
                                                                Set ToastTextHints = ToastTextElement.Hints
                                                                If ToastTextHints.Ifc <> 0& Then
                                                                    Dim ToastTextHintsCount As Long
                                                                    ToastTextHintsCount = ToastTextHints.GetSize
                                                                    If ToastTextHintsCount > 0& Then
                                                                        Dim ToastTextKeyValuePair() As KeyValuePair_HSTRING_HSTRING
                                                                        ToastTextKeyValuePair = ToastTextHints.GetKeyValuePairs
                                                                        Dim ToastTextHintsItem As Long
                                                                        For ToastTextHintsItem = 0 To ToastTextHintsCount - 1
                                                                            Debug.Print "ToastTextElementHints.key: " & ToastTextKeyValuePair(ToastTextHintsItem).key
                                                                            Debug.Print "ToastTextElementHints.value: " & ToastTextKeyValuePair(ToastTextHintsItem).value
                                                                        Next
                                                                    End If
                                                                    Set ToastTextHints = Nothing
                                                                End If
                                                                If ToastTextElementsItem = 0 Then
                                                                    ToastTitle = ToastTextElement.Text
                                                                Else
                                                                    ToastMessage = ToastMessage & ToastTextElement.Text
                                                                    If ToastTextElementsItem < ToastTextElementsCount - 1 Then
                                                                        ToastMessage = ToastMessage & vbNewLine
                                                                    End If
                                                                End If
                                                                Set ToastTextElement = Nothing
                                                            End If
                                                        Next
                                                        Debug.Print "ToastTitle: " & ToastTitle
                                                        Debug.Print "ToastMessage: " & vbNewLine & ToastMessage
                                                    End If
                                                    Set ToastTextElements = Nothing
                                                End If
                                                Set ToastVisualBinding = Nothing
                                            End If
                                        Next
                                    End If
                                    Set ToastVisualBindings = Nothing
                                End If
                                Set Toast = Nothing
                            End If
                            Set UsrNotification = Nothing
                        End If
                        Debug.Print String$(100, "-")
                    Next
                End If
                Set Notifications = Nothing
            End If
        End If
    End If
End Sub

